## ros-lunar-base-local-planner 1.15.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(base_local_planner)

find_package(catkin REQUIRED
        COMPONENTS
            angles
            cmake_modules
            costmap_2d
            dynamic_reconfigure
            geometry_msgs
            message_generation
            nav_core
            nav_msgs
            pcl_conversions
            pcl_ros
            pluginlib
            roscpp
            rospy
            std_msgs
            tf
            voxel_grid
        )

find_package(Boost REQUIRED
    COMPONENTS
        thread
        )

find_package(Eigen3 REQUIRED)
find_package(PCL REQUIRED COMPONENTS common)
remove_definitions(-DDISABLE_LIBUSB-1.0)
include_directories(
    include
    ${catkin_INCLUDE_DIRS}
    ${EIGEN3_INCLUDE_DIRS}
    ${PCL_INCLUDE_DIRS}
)
add_definitions(${EIGEN3_DEFINITIONS})

catkin_python_setup()

# messages
add_message_files(
    DIRECTORY msg
    FILES
    Position2DInt.msg
)

generate_messages(
    DEPENDENCIES
        std_msgs
)

# dynamic reconfigure
generate_dynamic_reconfigure_options(
    cfg/BaseLocalPlanner.cfg
)

catkin_package(
    INCLUDE_DIRS include
    LIBRARIES
        base_local_planner
        trajectory_planner_ros
    CATKIN_DEPENDS
        angles
        costmap_2d
        dynamic_reconfigure
        geometry_msgs
        message_runtime
        nav_core
        nav_msgs
        pluginlib
        roscpp
        std_msgs
        tf
)

#uncomment for profiling
#set(ROS_COMPILE_FLAGS "-g -pg" ${ROS_COMPILE_FLAGS})
#set(ROS_LINK_FLAGS "-g -pg" ${ROS_LINK_FLAGS})
#set(ROS_COMPILE_FLAGS "-g" ${ROS_COMPILE_FLAGS})
#set(ROS_LINK_FLAGS "-g" ${ROS_LINK_FLAGS})

add_library(base_local_planner
	src/footprint_helper.cpp
	src/goal_functions.cpp
	src/map_cell.cpp
	src/map_grid.cpp
	src/map_grid_visualizer.cpp
	src/map_grid_cost_function.cpp
	src/latched_stop_rotate_controller.cpp
	src/local_planner_util.cpp
	src/odometry_helper_ros.cpp
	src/obstacle_cost_function.cpp
	src/oscillation_cost_function.cpp
	src/prefer_forward_cost_function.cpp
	src/point_grid.cpp
	src/costmap_model.cpp
	src/simple_scored_sampling_planner.cpp
	src/simple_trajectory_generator.cpp
	src/trajectory.cpp
	src/twirling_cost_function.cpp
	src/voxel_grid_model.cpp)
add_dependencies(base_local_planner base_local_planner_gencfg)
add_dependencies(base_local_planner base_local_planner_generate_messages_cpp)
add_dependencies(base_local_planner nav_msgs_generate_messages_cpp)
target_link_libraries(base_local_planner
    ${catkin_LIBRARIES}
    ${PCL_LIBRARIES}
    ${Boost_LIBRARIES}
    ${Eigen_LIBRARIES}
    )

add_library(trajectory_planner_ros
	src/trajectory_planner.cpp
	src/trajectory_planner_ros.cpp)
add_dependencies(trajectory_planner_ros ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(trajectory_planner_ros
     base_local_planner)

add_executable(point_grid src/point_grid.cpp)
add_dependencies(point_grid ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(point_grid ${catkin_LIBRARIES})

install(TARGETS
            base_local_planner
            trajectory_planner_ros
       ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
       LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
       )

install(FILES blp_plugin.xml
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  PATTERN ".svn" EXCLUDE
)

if(CATKIN_ENABLE_TESTING)
  find_package(rostest)
  catkin_add_gtest(base_local_planner_utest
    test/gtest_main.cpp
    test/utest.cpp
    test/velocity_iterator_test.cpp
    test/footprint_helper_test.cpp
    test/trajectory_generator_test.cpp
    test/map_grid_test.cpp)
  target_link_libraries(base_local_planner_utest
      base_local_planner trajectory_planner_ros
      )

  catkin_add_gtest(line_iterator
      test/line_iterator_test.cpp)
endif()

=== debian/changelog ===
ros-lunar-base-local-planner (1.15.2-0stretch) stretch; urgency=high

  * Merge pull request #673 <https://github.com/ros-planning/navigation/issues/673> from ros-planning/email_update_lunar
    update maintainer email (lunar)
  * CostmapModel: Make lineCost and pointCost public (#658 <https://github.com/ros-planning/navigation/issues/658>)
    Make the methods lineCost and pointCost of the CostmapModel class
    public so they can be used outside of the class.
    Both methods are not changing the instance, so this should not cause any
    problems.  To emphasise their constness, add the actual const keyword.
  * Merge pull request #649 <https://github.com/ros-planning/navigation/issues/649> from aaronhoy/lunar_add_ahoy
    Add myself as a maintainer.
  * Contributors: Aaron Hoy, Felix Widmaier, Michael Ferguson

 -- David V. Lu!! <davidvlu@gmail.com>  Thu, 22 Mar 2018 07:00:00 -0000

ros-lunar-base-local-planner (1.15.1-0stretch) stretch; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Mon, 14 Aug 2017 07:00:00 -0000

ros-lunar-base-local-planner (1.15.0-0stretch) stretch; urgency=high

  * set message_generation build and runtime dependency
  * convert packages to format2
  * cleaner logic, fixes #156 <https://github.com/ros-planning/navigation/issues/156>
  * Merge pull request #596 <https://github.com/ros-planning/navigation/issues/596> from ros-planning/lunar_548
  * Add cost function to prevent unnecessary spinning
  * Fix CMakeLists + package.xmls (#548 <https://github.com/ros-planning/navigation/issues/548>)
  * add missing deps on libpcl
  * import only PCL common
  * pcl proagate -lQt5::Widgets flag so we need to find_package Qt5Widgets (#578 <https://github.com/ros-planning/navigation/issues/578>)
  * make rostest in CMakeLists optional (ros/rosdistro#3010 <https://github.com/ros/rosdistro/issues/3010>)
  * remove GCC warnings
  * Contributors: Lukas Bulwahn, Martin Günther, Michael Ferguson, Mikael Arguedas, Morgan Quigley, Vincent Rabaud, lengly

 -- David V. Lu!! <davidvlu@gmail.com>  Mon, 07 Aug 2017 07:00:00 -0000

ros-lunar-base-local-planner (1.14.0-0stretch) stretch; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Fri, 20 May 2016 07:00:00 -0000

ros-lunar-base-local-planner (1.13.1-0stretch) stretch; urgency=high

  * base_local_planner: some fixes in goal_functions
  * Merge pull request #348 <https://github.com/ros-planning/navigation/issues/348> from mikeferguson/trajectory_planner_fixes
  * fix stuck_left/right calculation
  * fix calculation of heading diff
  * Contributors: Gael Ecorchard, Michael Ferguson

 -- David V. Lu!! <davidvlu@gmail.com>  Thu, 29 Oct 2015 07:00:00 -0000

ros-lunar-base-local-planner (1.13.0-0stretch) stretch; urgency=high

  * remove previously deprecated param
  * Contributors: Michael Ferguson

 -- David V. Lu!! <davidvlu@gmail.com>  Tue, 17 Mar 2015 07:00:00 -0000

ros-lunar-base-local-planner (1.12.0-0stretch) stretch; urgency=high

  * update maintainer email
  * Contributors: Michael Ferguson

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 04 Feb 2015 08:00:00 -0000

ros-lunar-base-local-planner (1.11.15-0stretch) stretch; urgency=high

  * Add ARCHIVE_DESTINATION for static builds
  * Contributors: Gary Servin

 -- David V. Lu!! <davidvlu@gmail.com>  Tue, 03 Feb 2015 08:00:00 -0000

ros-lunar-base-local-planner (1.11.14-0stretch) stretch; urgency=high

  * Fixed setting child_frame_id in base_local_planner::OdometryHelperRos
  * Contributors: Mani Monajjemi

 -- David V. Lu!! <davidvlu@gmail.com>  Fri, 05 Dec 2014 08:00:00 -0000

ros-lunar-base-local-planner (1.11.13-0stretch) stretch; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Thu, 02 Oct 2014 07:00:00 -0000

ros-lunar-base-local-planner (1.11.12-0stretch) stretch; urgency=high

  * Bugfix uninitialised occ_cost variable usage
    This fixes #256 <https://github.com/ros-planning/navigation/issues/256>.
  * base_local_planner: adds waitForTransform
  * Fixed issue causing trajectory planner returning false to isGoalReach ed even when it's control thread finishes executing
  * Contributors: Daniel Stonier, Marcus Liebhardt, hes3pal

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 01 Oct 2014 07:00:00 -0000

ros-lunar-base-local-planner (1.11.11-0stretch) stretch; urgency=high

  * Minor code cleanup
  * Contributors: Enrique Fernández Perdomo

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 23 Jul 2014 07:00:00 -0000

ros-lunar-base-local-planner (1.11.10-0stretch) stretch; urgency=high

  * Remove unnecessary colons
  * renames acc_lim_th to acc_lim_theta, add warning if using acc_lim_th
  * uses odom child_frame_id to set robot_vel frame_id
  * Contributors: David Lu!!, Michael Ferguson, Enrique Fernández Perdomo

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 25 Jun 2014 07:00:00 -0000

ros-lunar-base-local-planner (1.11.9-0stretch) stretch; urgency=high

  * uses ::hypot(x, y) instead of sqrt(x*x, y*y)
  * No need to use limits->
  * Contributors: Enrique Fernández Perdomo

 -- David V. Lu!! <davidvlu@gmail.com>  Tue, 10 Jun 2014 07:00:00 -0000

ros-lunar-base-local-planner (1.11.8-0stretch) stretch; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 21 May 2014 07:00:00 -0000

ros-lunar-base-local-planner (1.11.7-0stretch) stretch; urgency=high

  * fixes latch_xy_goal_tolerance param not taken
  * update build to find eigen using cmake_modules
  * Trajectory: fix constness of getter methods
  * Use hypot() instead of sqrt(x*x, y*y)
  * Fix bug in distance calculation for trajectory rollout
  * Some documentation fixes in SimpleTrajectoryGenerator
  * Contributors: Michael Ferguson, Siegfried-A. Gevatter Pujals, enriquefernandez

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 21 May 2014 07:00:00 -0000

ros-lunar-base-local-planner (1.11.5-0stretch) stretch; urgency=high

  * Merge pull request #152 <https://github.com/ros-planning/navigation/issues/152> from KaijenHsiao/hydro-devel


=== debian/control ===
Source: ros-lunar-base-local-planner
Section: misc
Priority: extra
Maintainer: David V. Lu!! <davidvlu@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libpcl-dev, ros-lunar-angles, ros-lunar-catkin (>= 0.5.68), ros-lunar-cmake-modules, ros-lunar-costmap-2d, ros-lunar-dynamic-reconfigure, ros-lunar-geometry-msgs, ros-lunar-message-generation, ros-lunar-nav-core, ros-lunar-nav-msgs, ros-lunar-pcl-conversions, ros-lunar-pcl-ros, ros-lunar-pluginlib, ros-lunar-rosconsole, ros-lunar-roscpp, ros-lunar-rospy, ros-lunar-rosunit, ros-lunar-std-msgs, ros-lunar-tf, ros-lunar-visualization-msgs, ros-lunar-voxel-grid
Homepage: http://wiki.ros.org/base_local_planner
Standards-Version: 3.9.2

Package: ros-lunar-base-local-planner
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libpcl-dev, ros-lunar-angles, ros-lunar-costmap-2d, ros-lunar-dynamic-reconfigure, ros-lunar-geometry-msgs, ros-lunar-message-runtime, ros-lunar-nav-core, ros-lunar-nav-msgs, ros-lunar-pcl-ros, ros-lunar-pluginlib, ros-lunar-rosconsole, ros-lunar-roscpp, ros-lunar-rospy, ros-lunar-std-msgs, ros-lunar-tf, ros-lunar-visualization-msgs, ros-lunar-voxel-grid
Description: This package provides implementations of the Trajectory Rollout and Dynamic Window approaches to local robot navigation on a plane.
 Given a plan to follow and a costmap, the controller produces velocity commands to send to a mobile base. This package supports both holonomic and non-holonomic robots, any robot footprint that can be represented as a convex polygon or circle, and exposes its configuration as ROS parameters that can be set in a launch file. This package's ROS wrapper adheres to the BaseLocalPlanner interface specified in the nav_core package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-base-local-planner//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
